/*
Create a PShape for the cannon so that the position [0,0] 
 corresponds with the barrels' centre of rotation. This will
 also be the starting point for the shot.
 
 Not that setting the barrels rotation is cumulative so to  
 set it to a specific value the current rotation must be removed
 first.
 */
PShape createCannon() {
  // The overall PShape
  PShape cannon = createShape(GROUP);
  // Create the barrel
  PShape barrel = createShape(GROUP);
  PShape t;
  t = createShape(ELLIPSE, -26, 0, 6, 6);
  t.setStroke(false);
  t.setFill(color(100, 100, 110));
  barrel.addChild(t);

  t = createShape(ELLIPSE, -20, 0, 10, 16);
  t.setStroke(false);
  t.setFill(color(120, 120, 130));
  barrel.addChild(t);

  t = createShape();
  t.setStroke(false);
  t.setFill(color(120, 120, 130));
  t.beginShape();
  t.vertex(-20, -8);
  t.vertex(-20, 8);
  t.vertex(40, 5);
  t.vertex(40, -5);
  t.endShape(CLOSE);
  barrel.addChild(t);

  t = createShape(RECT, 32, -7, 6, 14, 4);
  t.setStroke(false);
  t.setFill(color(120, 120, 130));
  barrel.addChild(t);

  // Create the cannon's base
  PShape base = createShape(GROUP);
  t = createShape(RECT, -15, 0, 30, 10, 2);
  t.setStroke(false);
  t.setFill(color(64, 64, 32));
  base.addChild(t);

  t = createShape(RECT, -20, 8, 42, 10, 2);
  t.setStroke(false);
  t.setFill(color(64, 64, 32));
  base.addChild(t);

  t = createShape(RECT, -24, 16, 62, 10, 2);
  t.setStroke(false);
  t.setFill(color(64, 64, 32));
  base.addChild(t);

  // Add the base and barrel to the cannon PShape
  cannon.addChild(barrel);
  cannon.addChild(base);
  cannon.scale(0.7f);
  return cannon;
}